import { Action, ActionMeta } from 'redux-actions';
import { ActionCreator } from 'redux';
import { Effect } from 'redux-saga/effects';
import { ThunkAction } from 'redux-thunk';
interface AsyncMeta<T> {
    resolve: (result: T) => void;
    reject: (error: Error) => void;
}
export declare type Actions<Payload = any> = ActionMeta<Payload, AsyncMeta<any>>;
export declare type ThunkResult<Result, State> = ThunkAction<Result, State, undefined, Actions>;
declare type AsyncActionCreator<State> = {
    (...args: any[]): ThunkResult<Promise<any>, State>;
};
export declare const createAsyncAction: <State>(actionType: string, payloadCreator?: {
    <T>(value: T): T;
    (): undefined;
}) => AsyncActionCreator<State>;
export declare const createAsyncActions: <State, Payload = any>(actionType: string, ...args: any[]) => [AsyncActionCreator<State>, ActionCreator<Action<Payload>>, ActionCreator<Action<any>>];
export declare const createAsyncSaga: (originalSaga: (action: Actions<any>) => Generator<Effect<any, any>, any, unknown>) => (action: Actions<any>) => Generator<Effect<any, any>, any, any>;
export * from './reducer';
