"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const identity_1 = __importDefault(require("lodash/identity"));
const redux_actions_1 = require("redux-actions");
const effects_1 = require("redux-saga/effects");
exports.createAsyncAction = (actionType, payloadCreator = identity_1.default) => {
    const metaCreator = (...args) => {
        const [resolve, reject] = args.slice(-2);
        return {
            resolve,
            reject
        };
    };
    const actionCreator = (...args) => (dispatch) => new Promise((resolve, reject) => {
        dispatch(redux_actions_1.createAction(actionType, payloadCreator, metaCreator)(...args, resolve, reject));
    });
    actionCreator[Symbol.toPrimitive] = () => actionType;
    actionCreator.toString = () => actionType;
    return actionCreator;
};
exports.createAsyncActions = (actionType, ...args) => {
    const requestAction = exports.createAsyncAction(`${actionType}_REQUEST`, ...args);
    const successAction = redux_actions_1.createAction(`${actionType}_SUCCESS`);
    const failureAction = redux_actions_1.createAction(`${actionType}_FAILURE`);
    return [requestAction, successAction, failureAction];
};
exports.createAsyncSaga = (originalSaga) => function* newSaga(action) {
    const { meta } = action;
    try {
        const result = yield effects_1.call(originalSaga, action);
        if (meta === null || meta === void 0 ? void 0 : meta.resolve) {
            yield effects_1.call(meta.resolve, result);
        }
    }
    catch (error) {
        if (meta === null || meta === void 0 ? void 0 : meta.reject) {
            yield effects_1.call(meta.reject, error);
        }
    }
};
__export(require("./reducer"));
